package dicewars.model;

import javafx.scene.paint.Color;

/*
 * A DiceWars player
 * An immutable class
 *
 *  *** Nothing to do here! ***
 *
 */
public class Player {

    private final String name;  // Unique
    private final Color color;

    public Player(String name, Color color) {
        this.name = name;
        this.color = color;
    }

    public String getName() {
        return name;
    }

    public Color getColor() {
        return color;
    }

    @Override
    public boolean equals(Object o) { // Must have because we store hex's in collections!
        if (this == o) {
            return true;
        }
        if (!(o instanceof Player)) {
            return false;
        }
        Player player = (Player) o;
        return name.equals(player.name);
    }

    @Override
    public int hashCode() {
        return name.hashCode();
    } // Must have because we store hex's in maps!

    @Override
    public String toString() {
        return "Player{" + name + ", " + color + '}';
    }

}
